// Hauptframe-Klasse zum Anzeigen der Menuoberflche
// einige Methoden, z.B. die des Laden/Speicherns wurden teilweise mitintegriert


import java.awt.*;
import java.io.*;

public class Frame1 extends Frame
{
   	public Frame1()
	{
		
		//Bild unter dem "?"
		BildVonUns bildvonuns;
		
		//Allgemeine Einstellungen
		setLayout(null);
		setFont(new Font("Dialog", Font.PLAIN, 16));
		setSize(800,1);
		setVisible(false);
		
		//KlasseLaden Eingebemaske
		KlasseLaden.setMode(FileDialog.LOAD);
		KlasseLaden.setTitle("Open");
		KlasseLaden.setFile("*.kla");
		//PflichtenheftLaden Eingabemaske
		PflichtenheftLaden.setMode(FileDialog.LOAD);
		PflichtenheftLaden.setTitle("Open");
		PflichtenheftLaden.setFile("*.pfl");
		
		//ObjektLaden Eingabemaske
		ObjektLaden.setMode(FileDialog.LOAD);
		ObjektLaden.setTitle("Open");
		ObjektLaden.setFile("*.obj");
		
		//VerbindungLaden EingabeMaske
		VerbindungLaden.setMode(FileDialog.LOAD);
		VerbindungLaden.setTitle("Open");
		VerbindungLaden.setFile("*.ver");
		
		//UseCaseLaden EingabeMaske
		UseCaseLaden.setMode(FileDialog.LOAD);
		UseCaseLaden.setTitle("Open");
		UseCaseLaden.setFile("*.use");
		
		//Titel des Hauptframes
		setTitle("C.v.K. Mbert U.T.O.P.P. Version1");
	
		//Menuleiste
		setMenuBar(mainMenuBar);
		
		
		
		mainMenuBar.add(menu2);
		menu2.setLabel("Klasse");
		
		menu2.add(menuItem1);
		menuItem1.setLabel("Klasse hinzufgen");
		menu2.add(menuitem2);
		menuitem2.setLabel("Klasse laden");
		
		
		mainMenuBar.add(menu3);
		menu3.setLabel("Use-Case");
		
		menu3.add(menuItem2);
		menuItem2.setLabel("UseCase hinzufgen");
		menu3.add(menuItem4);
		menuItem4.setLabel("UseCase laden");
		
		
		mainMenuBar.add(menu4);
		menu4.setLabel("Objekt");
		
		menu4.add(menuItem3);
		menuItem3.setLabel("Objekt hinzufgen");
		menu4.add(menuItem5);
		menuItem5.setLabel("Objekt laden");
		
		
		mainMenuBar.add(menu5);
		menu5.setLabel("Verbindung");
		
		menu5.add(menuItem7);
		menuItem7.setLabel("Verbindung laden");
		menu5.add(menuItem6);
		menuItem6.setLabel("Verbindung hinzufgen");
		
				
		mainMenuBar.add(menu6);
		menu6.setLabel("Pflichtenheft");
		
		menu6.add(menuItem8);
		menuItem8.setLabel("Pflichtenheft hinzufgen");
		menu6.add(menuItem9);
		menuItem9.setLabel("Pflichenheft laden");
		
		
		mainMenuBar.add(menu7);
		menu7.setLabel("Programm");
		
		menu7.add(menuItem10);
		menuItem10.setLabel("beenden");
		
		
		mainMenuBar.add(menu8);
		menu8.setLabel("?");
		
		menu8.add(menuItem17);
		menuItem17.setLabel("ber C.V.K. Mbert - U-Topp");
		menu8.add(menuItem18);
		menuItem18.setLabel("Hilfe");
		menu8.add(menuItem19);
		menuItem19.setLabel("Documentation");
		
		
		//Bis hier hin nur Komponenten der MenuLeiste
			
		
		//ActionListerner fr den Frame und frs Menu
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		menuItem4.addActionListener(lSymAction);
		menuItem1.addActionListener(lSymAction);
		menuItem2.addActionListener(lSymAction);
		menuItem3.addActionListener(lSymAction);
		menuItem6.addActionListener(lSymAction);
		menuItem8.addActionListener(lSymAction);
		menuitem2.addActionListener(lSymAction);
		menuItem5.addActionListener(lSymAction);
		menuItem7.addActionListener(lSymAction);
		menuItem9.addActionListener(lSymAction);
		menuItem10.addActionListener(lSymAction);
		menuItem17.addActionListener(lSymAction);
	
	}

	//Ende von dem Aufbau des Frame1



	//Konstruktor
	public Frame1(String title)
	{
		this();
		setTitle(title);
	}
	
    
    
    //Methode zum Verstecken oder Zeigen des Frames
    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}	
		super.setVisible(b);
	}
	
	
	
	//Main Methode mit Fehlerbehebung, dahinter addNotify Methode
	//standard Methode in einem Frame (hat mit der Gre des Rahmens zu tun)
	
	static public void main(String args[])
	{
		try
		{
			//Frame1 sichtbar machen
    		(new Frame1()).setVisible(true);
		}
		catch (Throwable t)
		{
			System.err.println(t);
			t.printStackTrace();
		
			System.exit(1);
		}
	}
	
	
	
	public void addNotify()
	{
		
		Dimension d = getSize();
		
		super.addNotify();
	
		if (fComponentsAdjusted)
			return;
	
		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}
	
	//Variable zur addNotify Methode
	boolean fComponentsAdjusted = false;
	
	
	//Variablen fr Frame1 (alle "FileDialogues" zum Laden)
	java.awt.FileDialog KlasseLaden = new java.awt.FileDialog(this);
	java.awt.FileDialog PflichtenheftLaden = new java.awt.FileDialog(this);
	java.awt.FileDialog ObjektLaden = new java.awt.FileDialog(this);
	java.awt.FileDialog VerbindungLaden = new java.awt.FileDialog(this);
	java.awt.FileDialog UseCaseLaden = new java.awt.FileDialog(this);
	
	//Variablen fr Frame1 (alle Menupunkte)
	java.awt.MenuBar mainMenuBar = new java.awt.MenuBar();
	java.awt.Menu menu2 = new java.awt.Menu();
	java.awt.MenuItem menuItem1 = new java.awt.MenuItem();
	java.awt.MenuItem menuitem2 = new java.awt.MenuItem();
	java.awt.Menu menu3 = new java.awt.Menu();
	java.awt.MenuItem menuItem2 = new java.awt.MenuItem();
	java.awt.MenuItem menuItem4 = new java.awt.MenuItem();
	java.awt.Menu menu4 = new java.awt.Menu();
	java.awt.MenuItem menuItem3 = new java.awt.MenuItem();
	java.awt.MenuItem menuItem5 = new java.awt.MenuItem();
	java.awt.Menu menu5 = new java.awt.Menu();
	java.awt.MenuItem menuItem6 = new java.awt.MenuItem();
	java.awt.MenuItem menuItem7 = new java.awt.MenuItem();
	java.awt.Menu menu6 = new java.awt.Menu();
	java.awt.MenuItem menuItem8 = new java.awt.MenuItem();
	java.awt.MenuItem menuItem9 = new java.awt.MenuItem();
	java.awt.Menu menu7 = new java.awt.Menu();
	java.awt.MenuItem menuItem10 = new java.awt.MenuItem();
	java.awt.Menu menu8 = new java.awt.Menu();
	java.awt.MenuItem menuItem17 = new java.awt.MenuItem();
	java.awt.MenuItem menuItem18 = new java.awt.MenuItem();
	java.awt.MenuItem menuItem19 = new java.awt.MenuItem();
	
	
	//Klasse mit Methode zum schliessen des Fensters ber das "X" rechts oben
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == Frame1.this)
				Frame1_WindowClosing(event);
		}
	}
	
	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		Frame1_WindowClosing_Interaction1(event);
	}
	
	void Frame1_WindowClosing_Interaction1(java.awt.event.WindowEvent event)
	{
		try {
			// QuitDialog Create and show as modal
			(new QuitDialog(this, true)).setVisible(true);
		} catch (Exception e) {
		}
	}

	
	
	//ActionListener fr die Menubar
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == menuItem4)
				menuItem4_ActionPerformed(event);
			if (object == menuItem1)
				menuItem1_ActionPerformed(event);
			else if (object == menuItem2)
				menuItem2_ActionPerformed(event);
			else if (object == menuItem3)
				menuItem3_ActionPerformed(event);
			else if (object == menuItem6)
				menuItem6_ActionPerformed(event);
			else if (object == menuItem8)
				menuItem8_ActionPerformed(event);
			else if (object == menuitem2)
				menuitem2_ActionPerformed(event);
			else if (object == menuItem5)
				menuItem5_ActionPerformed(event);
			else if (object == menuItem7)
				menuItem7_ActionPerformed(event);
			else if (object == menuItem9)
				menuItem9_ActionPerformed(event);
			else if (object == menuItem10)
				menuItem10_ActionPerformed(event);
			else if (object == menuItem17)
				menuItem17_ActionPerformed(event);	
		}
	}

	
	//Methoden, die beim Auslsen der verschiedenen Menupunkte gestartet werden
	void menuItem4_ActionPerformed(java.awt.event.ActionEvent event)
	{
		menuItem4_ActionPerformed_Interaction1(event);
	}
	
	
	
	
	void menuItem1_ActionPerformed(java.awt.event.ActionEvent event)
	{		 
		menuItem1_ActionPerformed_Interaction1(event);
	}

	void menuItem1_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			//Klasseneingabemaske sichtbar machen
			(new Klassenmaske()).setVisible(true);
		} catch (Exception e) {
		}
	}
	
	
	
	
	void menuItem2_ActionPerformed(java.awt.event.ActionEvent event)
	{
		menuItem2_ActionPerformed_Interaction1(event);
	}

	void menuItem2_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			//UseCase Eingabemaske sichtbar machen
			(new UseCaseEM()).setVisible(true);
		} catch (Exception e) {
		}
	}
	
	
	
	
	void menuItem3_ActionPerformed(java.awt.event.ActionEvent event)
	{
		menuItem3_ActionPerformed_Interaction1(event);
	}

	void menuItem3_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			//Objekt Eingabemaske sichtbar machen
			(new ObjektEM()).setVisible(true);
		} catch (Exception e) {
		}
	}
	
	
	
	
	void menuItem6_ActionPerformed(java.awt.event.ActionEvent event)
	{
		menuItem6_ActionPerformed_Interaction1(event);
	}

	void menuItem6_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			//Verbindungs Eingabemaske sichtbar machen
			(new VerbindungEM()).setVisible(true);
		} catch (Exception e) {
		}
	}
	
	
	
	
	void menuItem8_ActionPerformed(java.awt.event.ActionEvent event)
	{		 
		menuItem8_ActionPerformed_Interaction1(event);
	}

	void menuItem8_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			//Pflichtenheft Eingabemaske sichtbar machen
			(new PflichtenheftEM()).setVisible(true);
		} catch (Exception e) {
		}
	}
	
	
	
	
	void menuitem2_ActionPerformed(java.awt.event.ActionEvent event)
	{
		menuitem2_ActionPerformed_Interaction1(event);
	}

	void menuitem2_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// KlasseLaden FileDialog sichtbar machen
			KlasseLaden.setVisible(true);
			
			// Klasse laden (in der Klasse Klasse selbst gibt es keine Methode laden
			String Filename = KlasseLaden.getFile();
			FileInputStream FIS = new FileInputStream(Filename);
			ObjectInputStream OIS = new ObjectInputStream(FIS);
			Klasse klasse = (Klasse)OIS.readObject();
			OIS.close();
			klassenMaler.malen(klasse);
		} catch (Exception e) 
		{
        }
	}
	
	
	
	
	void menuItem4_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// UseCaseLaden FileDialog sichtbar machen
			UseCaseLaden.setVisible(true);
			
			// UseCase laden (in der UseCase KLasse selbst gibt es keine Methode laden
			String Filename = UseCaseLaden.getFile();
			FileInputStream FIS = new FileInputStream(Filename);
			ObjectInputStream OIS = new ObjectInputStream(FIS);
			UseCase Usecase = (UseCase)OIS.readObject();
			OIS.close();
			
			// geladenen UseCase anzeigen
			usecaseMaler.malen(Usecase);
		} catch (Exception e) {
		}
	}
	
	
	
	
	void menuItem5_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		menuItem5_ActionPerformed_Interaction1(event);
	}

	void menuItem5_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
	    ObjektLaden.setVisible(true);
		try {
			// ObjektLaden FileDialog sichtbar machen
			String Filename = ObjektLaden.getFile();
			
			// Objekt laden
			FileInputStream FIS = new FileInputStream(Filename);
			ObjectInputStream OIS = new ObjectInputStream(FIS);
			Objekt objekt = (Objekt)OIS.readObject();
			OIS.close();
			objektMaler.malen(objekt);
		} catch (Exception e) 
		{ 
		}
	}
	
	
	
	
	void menuItem7_ActionPerformed(java.awt.event.ActionEvent event)
	{
		menuItem7_ActionPerformed_Interaction1(event);
	}

	void menuItem7_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// VerbindungLaden FileDialog sichtbar machen
			VerbindungLaden.setVisible(true);
			
			//Verbindung laden und anzeigen
			String Filename = VerbindungLaden.getFile();
			FileInputStream FIS = new FileInputStream(Filename);
			ObjectInputStream OIS = new ObjectInputStream(FIS);
			Verbindung verbindung = (Verbindung)OIS.readObject();
			OIS.close();
			verbindungsMaler.malen(verbindung);
		} catch (Exception e) {
		}
	}
	
	
	
	
	void menuItem9_ActionPerformed(java.awt.event.ActionEvent event)
	{		 
		menuItem9_ActionPerformed_Interaction1(event);
	}

	void menuItem9_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// PflichtenheftLaden FileDialog anzeigen
			PflichtenheftLaden.setVisible(true);
			
			//Pflichtenheft direkt in die Eingabemaske laden
			String Filename = PflichtenheftLaden.getFile();
			FileInputStream FIS = new FileInputStream(Filename);
			ObjectInputStream OIS = new ObjectInputStream(FIS);
			Pflichtenheft pflichtenheft = (Pflichtenheft)OIS.readObject();
			OIS.close();
			//hier kommt es in die Eingabemaske
			(new PflichtenheftEM(PflichtenheftLaden.getFile(),pflichtenheft.Muss,pflichtenheft.Wunsch,pflichtenheft.Grenz,
			pflichtenheft.Anwendungsbereiche,pflichtenheft.Zielgruppen,pflichtenheft.Betriebsbedingungen,
			pflichtenheft.Software,pflichtenheft.Hardware,pflichtenheft.Orgware,pflichtenheft.Schnittstellen,
			pflichtenheft.Funktionen,
			pflichtenheft.Klassen,
			pflichtenheft.LeistungenFunktionen,pflichtenheft.Leistungen,
			pflichtenheft.Funktional,pflichtenheft.Zuverl,pflichtenheft.Benutzbar,pflichtenheft.Effizienz,pflichtenheft.Aenderbar,
			pflichtenheft.Test,
			pflichtenheft.SoftUmgebung,pflichtenheft.HardUmgebung,pflichtenheft.OrgwareUmgebung,pflichtenheft.SchnittUmgebung,
			pflichtenheft.Ergaenzungen)).setVisible(true);
			
		} catch (Exception e) {
		}
	}
	
	
	
	
	void menuItem10_ActionPerformed(java.awt.event.ActionEvent event)
	{		 
		menuItem10_ActionPerformed_Interaction1(event);
	}

	void menuItem10_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// QuitDialog ist der Frame, der das Programm beenden kann
			(new QuitDialog(this, true)).setVisible(true);
		} catch (Exception e) {
		}
	}
	
	
	
	
	void menuItem17_ActionPerformed(java.awt.event.ActionEvent event)
	{		 
		menuItem17_ActionPerformed_Interaction1(event);
	}

	void menuItem17_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// Hier wird der Frame "BildVonUns" instantiiert
			BildVonUns bildvonuns = new BildVonUns();
		} catch (Exception e) {
		}
	}
		


	
}

