import java.awt.*;
import java.beans.*;

public class KlassenattributEM extends java.awt.Frame
{
    //instanziiert eine Klassenattribut-Eingabemaske mit default-Titel
	public KlassenattributEM()
	{
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setFont(new Font("Dialog", Font.PLAIN, 14));
		setSize(367,195);
		setVisible(false);
		add(KlassenTyp);
		KlassenTyp.setBounds(144,12,110,27);
		add(KlassenInit);
		KlassenInit.setBounds(144,48,110,27);
		add(KlassenZusich);
		KlassenZusich.setBounds(144,84,110,27);
		label2.setText("Typ");
		add(label2);
		label2.setBounds(12,12,118,24);
		label3.setText("Initialwert");
		add(label3);
		label3.setBounds(12,48,118,24);
		label4.setText("Zusicherungen");
		add(label4);
		label4.setBounds(12,84,108,24);
		label5.setText("{");
		add(label5);
		label5.setFont(new Font("Dialog", Font.BOLD, 18));
		label5.setBounds(120,84,12,24);
		label6.setText("}");
		add(label6);
		label6.setFont(new Font("Dialog", Font.BOLD, 18));
		label6.setBounds(264,84,12,24);
		button1.setLabel("Lschen");
		add(button1);
		button1.setBackground(java.awt.Color.lightGray);
		button1.setBounds(36,144,86,24);
		button6.setLabel("Abbrechen");
		add(button6);
		button6.setBackground(java.awt.Color.lightGray);
		button6.setBounds(144,144,86,24);
		button3.setLabel("OK");
		add(button3);
		button3.setBackground(java.awt.Color.lightGray);
		button3.setBounds(252,144,84,24);
		setTitle("Klassen-Eingabemaske");

		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		button3.addActionListener(lSymAction);
		button6.addActionListener(lSymAction);

	}
	
    //instanziiert eine Klassenattribut-Eingabemaske mit dem Titel title
	public KlassenattributEM(String title)
	{
		this();
		setTitle(title);
	}
	
	//instanziiert eine Klassenattribut-Eingabemaske fr eine Klassenmaske km
	public KlassenattributEM(Klassenmaske km, String title)
	{
		this();
		setTitle(title);
		klassenmaske = km;
		actattri = klassenmaske.actualAttribut();
		KlassenTyp.setText(actattri.getTyp());
		KlassenZusich.setText(actattri.getZusicherung());
		KlassenInit.setText(actattri.getInitialwert());
		
	}
	
	//macht den Frame (un-)sichtbar
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

    //Haupt-Operation - eigentlich berlssig
	static public void main (String args[])
	{
		(new KlassenattributEM()).setVisible(true);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == KlassenattributEM.this)
			KlassenattributEM_WindowClosing(event);
		}
	}

    
	void KlassenattributEM_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();
	}
	
	java.awt.TextField KlassenTyp = new java.awt.TextField();
	java.awt.TextField KlassenInit = new java.awt.TextField();
	java.awt.TextField KlassenZusich = new java.awt.TextField();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.Label label6 = new java.awt.Label();
	java.awt.Button button1 = new java.awt.Button();
	java.awt.Button button6 = new java.awt.Button();
	java.awt.Button button3 = new java.awt.Button();


	Klassenmaske klassenmaske;
	Attribut actattri;


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_ActionPerformed(event);
			else if (object == button6)
				button6_ActionPerformed(event);
		    else if (object == button3)
		        button3_ActionPerformed(event);
		}
	}
    
    //Implementation des Lschen-Buttons
	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		button1_ActionPerformed_Interaction1(event);
			 
		button1_ActionPerformed_Interaction3(event);
			 
		button1_ActionPerformed_Interaction4(event);
	}

	void button1_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			KlassenTyp.setText("");
		} catch (Exception e) {
		}
	}

	void button1_ActionPerformed_Interaction3(java.awt.event.ActionEvent event)
	{
		try {
			KlassenInit.setText("");
		} catch (Exception e) {
		}
	}

	void button1_ActionPerformed_Interaction4(java.awt.event.ActionEvent event)
	{
		try {
			KlassenZusich.setText("");
		} catch (Exception e) {
		}
	}
    
    //Implementation des OK-Buttons
    void button3_ActionPerformed(java.awt.event.ActionEvent event)
    {
        try {
            this.setVisible(false);
			klassenmaske.setTypvariable(KlassenTyp.getText());
			klassenmaske.speicherTyp();
			klassenmaske.setInitvariable(KlassenInit.getText());
			klassenmaske.speicherInit();
			klassenmaske.setZusichvariable(KlassenZusich.getText());
			klassenmaske.speicherAttZusi();
			System.out.println("Typ, Initialwert und Zusicherung gespeichert");
			klassenmaske.setVisible(true);
        } catch(Exception e) {
        }
    }
    
    //Implementation des Abbrechen-Buttons
	void button6_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		button6_ActionPerformed_Interaction1(event);
	}

	void button6_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.setVisible(false);
			klassenmaske.setVisible(true);
		} catch (Exception e) {
		}
	}
}