//Klassenmaske zur Eingabe der Klassendaten

import java.awt.*;
import java.beans.*;
import java.util.*;

public class Klassenmaske extends java.awt.Frame
{
    public Klassenmaske()
	{
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setFont(new Font("Dialog", Font.PLAIN, 14));
		setSize(494,576);
		setVisible(false);
		add(KlassenName);
		KlassenName.setBounds(168,36,110,27);
		add(KlassenStereotyp);
		KlassenStereotyp.setBounds(168,84,110,27);
		add(KlassenPacket);
		KlassenPacket.setBounds(60,156,110,27);
		add(KlassenKlasse);
		KlassenKlasse.setBounds(204,156,110,27);
		add(KlassenEigenschaften);
		KlassenEigenschaften.setBounds(132,192,110,27);
		add(AttributCombo);
		AttributCombo.setBounds(132,252,156,26);
		button1.setLabel("Attribut editieren...");
		add(button1);
		button1.setBackground(java.awt.Color.lightGray);
		button1.setBounds(300,240,156,24);
		button8.setLabel("Attribut lschen");
		add(button8);
		button8.setBackground(java.awt.Color.lightGray);
		button8.setBounds(300,276,156,24);
		add(KlassenAttribut);
		KlassenAttribut.setBounds(132,324,156,24);
		button3.setLabel("Attribut hinzufgen");
		add(button3);
		button3.setBackground(java.awt.Color.lightGray);
		button3.setBounds(300,324,156,24);
		add(OperationCombo);
		OperationCombo.setBounds(132,408,156,26);
		button2.setLabel("Operation editieren...");
		add(button2);
		button2.setBackground(java.awt.Color.lightGray);
		button2.setBounds(300,396,156,24);
		button9.setLabel("Operation lschen");
		add(button9);
		button9.setBackground(java.awt.Color.lightGray);
		button9.setBounds(300,432,156,24);
		add(KlassenOperation);
		KlassenOperation.setBounds(132,480,156,24);
		button4.setLabel("Operation hinzufgen");
		add(button4);
		button4.setBackground(java.awt.Color.lightGray);
		button4.setBounds(300,480,156,24);
		label1.setText("Name");
		add(label1);
		label1.setBounds(12,36,104,26);
		label2.setText("Stereotyp  ");
		add(label2);
		label2.setBounds(12,84,72,24);
		label3.setText("Packet");
		add(label3);
		label3.setBounds(96,132,48,24);
		label4.setText(": :");
		add(label4);
		label4.setFont(new Font("Dialog", Font.BOLD, 14));
		label4.setBounds(180,156,12,24);
		label5.setText("Klasse");
		add(label5);
		label5.setBounds(228,132,48,24);
		label6.setText(">>");
		add(label6);
		label6.setFont(new Font("Dialog", Font.BOLD, 14));
		label6.setBounds(288,84,24,24);
		label7.setText("<<");
		add(label7);
		label7.setFont(new Font("Dialog", Font.BOLD, 14));
		label7.setBounds(144,84,24,24);
		label8.setText("Eigenschaftswerte");
		add(label8);
		label8.setBounds(12,192,104,26);
		label9.setText("Attribute");
		add(label9);
		label9.setBounds(12,240,72,24);
		label10.setText("{");
		add(label10);
		label10.setFont(new Font("Dialog", Font.BOLD, 18));
		label10.setBounds(120,192,12,24);
		label11.setText("}");
		add(label11);
		label11.setFont(new Font("Dialog", Font.BOLD, 18));
		label11.setBounds(252,192,12,24);
		label12.setText("Operationen");
		add(label12);
		label12.setBounds(12,396,84,24);
		Publik.setCheckboxGroup(Group1);
		Publik.setState(true);
		Publik.setLabel("public");
		add(Publik);
		Publik.setBounds(336,24,108,24);
		Privat.setCheckboxGroup(Group1);
		Privat.setLabel("private");
		add(Privat);
		Privat.setBounds(336,48,108,24);
		Protected.setCheckboxGroup(Group1);
		Protected.setLabel("protected");
		add(Protected);
		Protected.setBounds(336,72,108,24);
		Statisch.setState(true);
		Statisch.setLabel("static");
		add(Statisch);
		Statisch.setBounds(336,132,96,24);
		button6.setLabel("Abbrechen");
		add(button6);
		button6.setBackground(java.awt.Color.lightGray);
		button6.setBounds(180,540,86,24);
		button7.setLabel("OK");
		add(button7);
		button7.setBackground(java.awt.Color.lightGray);
		button7.setBounds(300,540,86,24);
		KlasseSpeichern.setMode(FileDialog.SAVE);
		KlasseSpeichern.setTitle("Save");
		KlasseSpeichern.setFile("*.kla");
		//$$ KlasseSpeichern.move(0,577);
		//$$ SaveFileDialog.move(0,577);
		setTitle("neue Klasse");

		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
		button6.addActionListener(lSymAction);
		button3.addActionListener(lSymAction);
		button4.addActionListener(lSymAction);
		button9.addActionListener(lSymAction);
		button7.addActionListener(lSymAction);
		button8.addActionListener(lSymAction);
	}
	
	public Klassenmaske(Klasse k) {
	    this();
	    KlassenName.setText(k.getName());
	    KlassenStereotyp.setText(k.getStereotyp());
	    KlassenPacket.setText(k.getPaket());
	    KlassenKlasse.setText(k.getPaketKlasse());
	    KlassenEigenschaften.setText(k.getEigenschaftswerte()); 
	    Statisch.setState(k.getisStatic());
	    switch(k.getEigenschaften()) {
	        case 0:
	            Publik.setState(true);
	            break;
	        case 1:
	            Privat.setState(true);
	            break;
	        case 2:
	            Protected.setState(true);
	            break;
	    }
	    Attribute = k.getAttribute();
	    for(int i=0; i<Attribute.capacity(); i++) {
	        AttributCombo.add(((Attribut)Attribute.elementAt(i)).getName());
	    }
	    Operationen = k.getOperationen();
	    for(int i=0; i<Operationen.capacity(); i++) {
	        OperationCombo.add(((Operation)Operationen.elementAt(i)).getName());
	    }
	}



	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	static public void main (String args[])
	{
	}

	public void addNotify()
	{
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == Klassenmaske.this)
			Klassenmaske_WindowClosing(event);
		}
	}

	void Klassenmaske_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 
	}
	java.awt.TextField KlassenName = new java.awt.TextField();
	java.awt.TextField KlassenStereotyp = new java.awt.TextField();
	java.awt.TextField KlassenPacket = new java.awt.TextField();
	java.awt.TextField KlassenKlasse = new java.awt.TextField();
	java.awt.TextField KlassenEigenschaften = new java.awt.TextField();
	java.awt.Choice AttributCombo = new java.awt.Choice();
	java.awt.Button button1 = new java.awt.Button();
	java.awt.Button button8 = new java.awt.Button();
	java.awt.TextField KlassenAttribut = new java.awt.TextField();
	java.awt.Button button3 = new java.awt.Button();
	java.awt.Choice OperationCombo = new java.awt.Choice();
	java.awt.Button button2 = new java.awt.Button();
	java.awt.Button button9 = new java.awt.Button();
	java.awt.TextField KlassenOperation = new java.awt.TextField();
	java.awt.Button button4 = new java.awt.Button();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.Label label6 = new java.awt.Label();
	java.awt.Label label7 = new java.awt.Label();
	java.awt.Label label8 = new java.awt.Label();
	java.awt.Label label9 = new java.awt.Label();
	java.awt.Label label10 = new java.awt.Label();
	java.awt.Label label11 = new java.awt.Label();
	java.awt.Label label12 = new java.awt.Label();
	java.awt.Checkbox Publik = new java.awt.Checkbox();
	java.awt.CheckboxGroup Group1 = new java.awt.CheckboxGroup();
	java.awt.Checkbox Privat = new java.awt.Checkbox();
	java.awt.Checkbox Protected = new java.awt.Checkbox();
	java.awt.Checkbox Statisch = new java.awt.Checkbox();
	java.awt.Button button6 = new java.awt.Button();
	java.awt.Button button7 = new java.awt.Button();
	java.awt.FileDialog KlasseSpeichern = new java.awt.FileDialog(this);
	Vector Attribute = new Vector(0,1);
	Vector Operationen = new Vector(0,1);
	//Variablen, die von der "KlasenOperationenEM" geaendert werden knnen
	String parameter;
	String zusicherung;
	//Variablen, die von der KlassenAttributEM geaendert werden knnen
	String typ;
	String initialwert;
	String attzusicherung;
	


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_ActionPerformed(event);
			else if (object == button2)
				button2_ActionPerformed(event);
			if (object == button6)
				button6_ActionPerformed(event);
			else if (object == button3)
				button3_ActionPerformed(event);
			else if (object == button4)
				button4_ActionPerformed(event);
			else if (object == button9)
				button9_ActionPerformed(event);
			else if (object == button7)
				button7_ActionPerformed(event);
			else if (object == button8)
				button8_ActionPerformed(event);
		}
	}

    public Attribut actualAttribut() {
        Attribut actAtt = null;
        try {
            System.out.println(Attribute.capacity());
            for(int i=0; i<Attribute.capacity(); i++) {
                if(((Attribut)Attribute.elementAt(i)).getName().compareTo(AttributCombo.getSelectedItem()) == 0) {
                    actAtt = (Attribut)Attribute.elementAt(i);
                }
            }
        } catch(Exception e) {System.err.println("Fehler in actualAttribut()"); }
        return actAtt;
    }

    public Operation actualOperation() {
        Operation actOp = null;
        try {
            System.out.println(Operationen.capacity());
            for(int i=0; i<Operationen.capacity(); i++) {
                if(((Operation)Operationen.elementAt(i)).getName().compareTo(OperationCombo.getSelectedItem()) == 0) {
                    actOp = (Operation)Operationen.elementAt(i);
                }
            }
        } catch(Exception e) {System.err.println("Fehler in actualOperation()"); }
        return actOp;
    }

    //Implementiert Button Attributwerte setzen
	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button1_ActionPerformed_Interaction1(event);
	}

	void button1_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.setVisible(false);
			(new KlassenattributEM(this, AttributCombo.getSelectedItem())).setVisible(true);
            
        } catch (Exception e) 
		{
		}
	}
    
    //Implentiert Button Operationswerte setzen
	void button2_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button2_ActionPerformed_Interaction1(event);
	}
	
	
	void button2_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.setVisible(false);
			(new KlassenoperationenEM(this, OperationCombo.getSelectedItem())).setVisible(true);
		} catch (Exception e) {
		}
	}
	

	
	//Implementiert Abbrechen-Button
	void button6_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button6_ActionPerformed_Interaction1(event);
	}

	
	void button6_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.setVisible(false);
		} catch (Exception e) {
		}
	}
    
    //Implementiert Attribut-hinzufgen-Button
	void button3_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		button3_ActionPerformed_Interaction1(event);
			 
		button3_ActionPerformed_Interaction2(event);
	}

	void button3_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			AttributCombo.addItem(KlassenAttribut.getText());
		    Attribute.addElement(new Attribut(KlassenAttribut.getText(), " ", " ", " "));
		} catch (Exception e) {
		}
	}

	void button3_ActionPerformed_Interaction2(java.awt.event.ActionEvent event)
	{
		try {
			KlassenAttribut.setText("");
		} catch (Exception e) {
		}
	}

    //Implementiert Operation-hinzufgen-Button
	void button4_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button4_ActionPerformed_Interaction1(event);
			 
		button4_ActionPerformed_Interaction2(event);
	}

	void button4_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			OperationCombo.addItem(KlassenOperation.getText());
			Operationen.addElement(new Operation(KlassenOperation.getText(), " ", " "));
		} catch (Exception e) {
		}
	}

	void button4_ActionPerformed_Interaction2(java.awt.event.ActionEvent event)
	{
		try {
			KlassenOperation.setText("");
		} catch (Exception e) {
		}
	}
	
	//Implementiert OK-Button
	void button7_ActionPerformed(java.awt.event.ActionEvent event) {
	    
			button7_ActionPerformed_Interaction1(event);
	    
	}
	
	void button7_ActionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			KlasseSpeichern.setVisible(true);
			// Speichere die Datei Filename
			String Filename = new String(KlasseSpeichern.getFile());
			int eigenschaften = 0;
			if(Publik.getState()) eigenschaften=0;
			else if(Privat.getState()) eigenschaften=1;
			else if(Protected.getState()) eigenschaften=2;
			Klasse neueKla = new Klasse(Filename, KlassenName.getText(), KlassenStereotyp.getText(), 
			    KlassenPacket.getText(), KlassenKlasse.getText(), KlassenEigenschaften.getText(),
			    Statisch.getState(),eigenschaften, Attribute, Operationen);
			neueKla.speichern();		
			klassenMaler.malen(neueKla);
			this.setVisible(false);
			} catch(Exception e) 
			{
			}
			
		}

	// Implementiert Attribut-Lschen-Button
	void button8_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button8_ActionPerformed_Interaction1(event);
	}

	void button8_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			AttributCombo.remove(AttributCombo.getSelectedItem());
		} catch (Exception e) {
		}
	}

    // Implementiert Operation-Lschen-Button
	void button9_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button9_ActionPerformed_Interaction1(event);
	}


	void button9_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			OperationCombo.remove(OperationCombo.getSelectedItem());
		} catch (Exception e) {
		}
	}


	
	public void setTypvariable(String t)
	{
		typ = t;
	}
	
	public void setInitvariable(String i)
	{
		initialwert = i;
		
	}
			
	public void setZusichvariable(String z)
	{
		attzusicherung = z;
	}
	
	public void speicherAttZusi()
	{
		actualAttribut().setZusicherung(attzusicherung);
		attzusicherung = " "; 
	}
	public void speicherTyp()
	{
		actualAttribut().setTyp(typ);
		typ = " "; 
	}
	public void speicherInit()
	{
		actualAttribut().setInitialwert(initialwert);
		initialwert =" "; 
	}
		
	public void setparametervariable(String p)
	{
		parameter = p;
	}
		
	public void setzusicherungsvariable(String y)
	{
		zusicherung = y;
	}
	
	public void speicherZusicherung()
	{
		actualOperation().setZusicherung(zusicherung);
		zusicherung = " "; 
	}
	
	public void speicherPara()
	{
		actualOperation().setParameter(parameter);
		parameter = " "; 
	}
	
	
}
