import java.awt.*;
import java.beans.*;

public class KlassenoperationenEM extends java.awt.Frame
{
	public KlassenoperationenEM()
	{
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setFont(new Font("Dialog", Font.PLAIN, 14));
		setSize(352,170);
		setVisible(false);
		add(OperationPara);
		OperationPara.setBounds(144,24,110,27);
		add(OperationZusi);
		OperationZusi.setBounds(144,60,110,27);
		button1.setLabel("Lschen");
		add(button1);
		button1.setBackground(java.awt.Color.lightGray);
		button1.setBounds(36,120,86,24);
		button6.setLabel("Abbrechen");
		add(button6);
		button6.setBackground(java.awt.Color.lightGray);
		button6.setBounds(144,120,86,24);
		button3.setLabel("OK");
		add(button3);
		button3.setBackground(java.awt.Color.lightGray);
		button3.setBounds(252,120,84,24);
		label5.setText("{");
		add(label5);
		label5.setFont(new Font("Dialog", Font.BOLD, 18));
		label5.setBounds(120,60,12,24);
		label4.setText("Zusicherungen");
		add(label4);
		label4.setBounds(12,60,108,24);
		label6.setText("}");
		add(label6);
		label6.setFont(new Font("Dialog", Font.BOLD, 18));
		label6.setBounds(264,60,12,24);
		label2.setText("Parameter");
		add(label2);
		label2.setBounds(12,24,118,24);
		setTitle("A Simple Frame");

		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		button3.addActionListener(lSymAction);
		button6.addActionListener(lSymAction);
	}

	public KlassenoperationenEM(String title)
	{
		this();
		setTitle(title);
	}
	
	public KlassenoperationenEM(Klassenmaske km, String title)
	{
		this();
		setTitle(title);
		klassenmaske = km;
		actoper = klassenmaske.actualOperation();
		OperationZusi.setText(actoper.getZusicherung());
		OperationPara.setText(actoper.getParameter());
	}	
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	static public void main (String args[])
	{
		(new KlassenoperationenEM()).setVisible(true);
	}

	public void addNotify()
	{
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == KlassenoperationenEM.this)
			KlassenoperationenEM_WindowClosing(event);
		}
	}

	void KlassenoperationenEM_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 
	}
	java.awt.TextField OperationPara = new java.awt.TextField();
	java.awt.TextField OperationZusi = new java.awt.TextField();
	java.awt.Button button1 = new java.awt.Button();
	java.awt.Button button6 = new java.awt.Button();
	java.awt.Button button3 = new java.awt.Button();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.Label label6 = new java.awt.Label();
	java.awt.Label label2 = new java.awt.Label();


	Klassenmaske klassenmaske;
	Operation actoper;


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_ActionPerformed(event);
			else if (object == button6)
				button6_ActionPerformed(event);
			else if (object == button3)
			    button3_ActionPerformed(event);
		}
	}

    // Implementiert Lschen-Button
	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button1_ActionPerformed_Interaction2(event);
			 
		button1_ActionPerformed_Interaction3(event);
	}

	void button1_ActionPerformed_Interaction2(java.awt.event.ActionEvent event)
	{
		try {
			OperationPara.setText("");
		} catch (Exception e) {
		}
	}

	void button1_ActionPerformed_Interaction3(java.awt.event.ActionEvent event)
	{
		try {
			OperationZusi.setText("");
		} catch (Exception e) {
		}
	}
	
	//Implementiert OK-Button
	void button3_ActionPerformed(java.awt.event.ActionEvent event) {
	    try {
	    this.setVisible(false);
		klassenmaske.setparametervariable(OperationPara.getText());
		klassenmaske.speicherPara();
		klassenmaske.setzusicherungsvariable(OperationZusi.getText());
		klassenmaske.speicherZusicherung();
		klassenmaske.setVisible(true);
		
	    } catch(Exception e) {
	    }
	}
    
    //Implementiert Abbrechen-Button
	void button6_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		button6_ActionPerformed_Interaction1(event);
	}

	void button6_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.setVisible(false);
			klassenmaske.setVisible(true);
		} catch (Exception e) {
		}
	}
}