// Klasse Objekt-Eingabemaske

import java.awt.*;
import java.beans.*;
import java.util.*;

public class ObjektEM extends java.awt.Frame
{
	public ObjektEM()
	{
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setFont(new Font("Dialog", Font.PLAIN, 14));
		setSize(476,300);
		setVisible(false);
		label1.setText("Objektname");
		add(label1);
		label1.setBounds(36,24,84,24);
		label2.setText("Objektzugehoerige Klasse");
		add(label2);
		label2.setBounds(216,24,180,24);
		label3.setText("Attribut");
		add(label3);
		label3.setBounds(36,96,84,24);
		add(ObjName);
		ObjName.setBounds(36,60,124,24);
		add(ObjektKlasse);
		ObjektKlasse.setBounds(216,60,168,24);
		add(ObjektAttriCombo);
		ObjektAttriCombo.setBounds(36,132,156,26);
		button7.setLabel("Initialwert setzen");
		add(button7);
		button7.setBackground(java.awt.Color.lightGray);
		button7.setBounds(228,120,135,25);
		button8.setLabel("Attribut lschen");
		add(button8);
		button8.setBackground(java.awt.Color.lightGray);
		button8.setBounds(228,156,135,25);
		add(ObjektAttri);
		ObjektAttri.setBounds(36,204,156,24);
		button1.setLabel("Attribut hinzufgen");
		add(button1);
		button1.setBackground(java.awt.Color.lightGray);
		button1.setBounds(228,204,135,25);
		button2.setLabel("Lschen");
		add(button2);
		button2.setBackground(java.awt.Color.lightGray);
		button2.setBounds(60,252,86,24);
		button3.setLabel("Abbrechen");
		add(button3);
		button3.setBackground(java.awt.Color.lightGray);
		button3.setBounds(180,252,86,24);
		button4.setLabel("OK");
		add(button4);
		button4.setBackground(java.awt.Color.lightGray);
		button4.setBounds(300,252,86,24);
		ObjektSpeichern.setMode(FileDialog.SAVE);
		ObjektSpeichern.setTitle("Save");
		ObjektSpeichern.setFile("*.obj");
		setTitle("Bitte Objekt eingeben");

		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymFocus aSymFocus = new SymFocus();
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
		button3.addActionListener(lSymAction);
		button7.addActionListener(lSymAction);
		button4.addActionListener(lSymAction);
		button8.addActionListener(lSymAction);
	}

	public ObjektEM(String title)
	{
		this();
		setTitle(title);
	}
	
	public ObjektEM(Objekt o) {
	    this();
	    ObjName.setText(o.getName());
	    ObjektKlasse.setText(o.getOberKlasse());
		InAttribute = o.getInAttribute();
	    for(int i=0; i<InAttribute.capacity(); i++) {
	        ObjektAttriCombo.add(((Attribut)InAttribute.elementAt(i)).getName());
	    }
	    this.setVisible(true);
	}
	
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	static public void main (String args[])
	{
		(new ObjektEM()).setVisible(true);
	}

	public void addNotify()
	{
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	boolean fComponentsAdjusted = false;
	
	//gibt ein Attribut zurck und zwar: 
    public Attribut actualAttribut() {
        Attribut actAtt = null;
        try {
            System.out.println(InAttribute.capacity());
            for(int i=0; i<InAttribute.capacity(); i++) {
                if(((Attribut)InAttribute.elementAt(i)).getName().compareTo(ObjektAttriCombo.getSelectedItem()) == 0) {
                    actAtt = (Attribut)InAttribute.elementAt(i);
                }
            }
        } catch(Exception e) {System.err.println(); System.err.println("actualAttribut()"); System.err.println(e.toString()); System.err.println(e.getMessage()); }
        return actAtt;
    }
    
	
	
	
	
	
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == ObjektEM.this)
			ObjektEM_WindowClosing(event);
		}
	}

	void ObjektEM_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 
	}
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.TextField ObjName = new java.awt.TextField();
	java.awt.TextField ObjektKlasse = new java.awt.TextField();
	java.awt.Choice ObjektAttriCombo = new java.awt.Choice();
	java.awt.Button button7 = new java.awt.Button();
	java.awt.Button button8 = new java.awt.Button();
	java.awt.TextField ObjektAttri = new java.awt.TextField();
	java.awt.Button button1 = new java.awt.Button();
	java.awt.Button button2 = new java.awt.Button();
	java.awt.Button button3 = new java.awt.Button();
	java.awt.Button button4 = new java.awt.Button();
	java.awt.FileDialog ObjektSpeichern = new java.awt.FileDialog(this);
	
	Vector InAttribute = new Vector(0,1);
	
	//Die Variable, die beim Aufruf des "Initialwert setzen"-Buttons geaendert wird
	String initialwert;
	
	class SymFocus extends java.awt.event.FocusAdapter
	{
		public void focusGained(java.awt.event.FocusEvent event)
		{
		}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_ActionPerformed(event);
			else if (object == button2)
				button2_ActionPerformed(event);
			else if (object == button3)
				button3_ActionPerformed(event);
			else if (object == button7)
				button7_ActionPerformed(event);
			else if (object == button4)
				button4_ActionPerformed(event);
			else if (object == button8)
				button8_ActionPerformed(event);
		}
	}
	
    //Attribut-hinzufgen-Button
	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button1_ActionPerformed_Interaction1(event);
			 
		button1_ActionPerformed_Interaction2(event);
	}
	
	void button1_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			ObjektAttriCombo.addItem(ObjektAttri.getText());
			InAttribute.addElement(new Attribut(ObjektAttri.getText(), " "," "," "));
		} catch (Exception e) {
		}
	}

	void button1_ActionPerformed_Interaction2(java.awt.event.ActionEvent event)
	{
		try {
			ObjektAttri.setText("");
		} catch (Exception e) {
		}
	}

    //Lschen-Button
	void button2_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button2_ActionPerformed_Interaction1(event);
	}

	void button2_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			ObjName.setText(" ");
		} catch (Exception e) {
		}
	}

    //Abbrechen-Button
	void button3_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button3_ActionPerformed_Interaction1(event);
			 
		button3_ActionPerformed_Interaction2(event);
	}

	void button3_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.setVisible(false);
		} catch (Exception e) {
		}
	}

	void button3_ActionPerformed_Interaction2(java.awt.event.ActionEvent event)
	{
		try {
			this.setVisible(false);
		} catch (Exception e) {
		}
	}


    //Attributwerte-setzen-Button
	void button7_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button7_ActionPerformed_Interaction1(event);
	}

	void button7_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.setVisible(false);
			(new ObjektattributeEM(this, ObjektAttriCombo.getSelectedItem())).setVisible(true);
		} catch (Exception e) 
		{ 
		}
	}

    //OK-Button
	void button4_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button4_ActionPerformed_Interaction1(event);
			 
		button4_ActionPerformed_Interaction2(event);			 
	}

	void button4_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
		    ObjektSpeichern.setVisible(true);
			// Speichere die Datei Filename
			Objekt neuesObj = new Objekt(
				ObjektSpeichern.getFile(), 
				ObjName.getText(), 
				ObjektKlasse.getText(), InAttribute);
			neuesObj.speichern();
			objektMaler.malen(neuesObj);
			} 
		catch (Exception e) 
			{     
			}
	}

	void button4_ActionPerformed_Interaction2(java.awt.event.ActionEvent event)
	{
		try {
			this.setVisible(false);
		} catch (Exception e) {
		}
	}

	void button8_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button8_ActionPerformed_Interaction1(event);
	}

	void button8_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			ObjektAttriCombo.remove(ObjektAttriCombo.getSelectedItem());
		} catch (Exception e) {
		}
	}
	
	public void setinitialwertvariable(String init)
	{
		initialwert = init;
	}
	
	public void speicherInitalwert()
	{
		actualAttribut().setInitialwert(initialwert);
		initialwert = " ";
	}	
}