// Klasse zur Klasse UseCaseEM
// Autor: Ralph Carrie

import java.awt.*;
import java.beans.*;

public class UseCaseEM extends java.awt.Frame
{
	public UseCaseEM()
	{
		//Layout des Frames
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setFont(new Font("Dialog", Font.PLAIN, 14));
		setSize(553,576);
		setVisible(false);
		label3.setText("Nummer");
		add(label3);
		label3.setBounds(24,36,108,24);
		add(UseCaseNummer);
		UseCaseNummer.setBounds(132,36,110,27);
		add(UseCaseName);
		UseCaseName.setBounds(132,72,110,27);
		add(UseCaseAkteur);
		UseCaseAkteur.setBounds(132,108,110,27);
		add(UseCaseVorbed);
		UseCaseVorbed.setBounds(132,144,240,27);
		add(UseCaseNachbed);
		UseCaseNachbed.setBounds(132,180,240,27);
		add(UseCaseInvar);
		UseCaseInvar.setBounds(132,216,240,27);
		add(UseCaseAblauf);
		UseCaseAblauf.setBounds(168,264,188,131);
		add(UseCaseVariationen);
		UseCaseVariationen.setBounds(132,408,110,24);
		button4.setLabel("Erweitert....");
		add(button4);
		button4.setBackground(java.awt.Color.lightGray);
		button4.setBounds(324,408,108,24);
		button3.setLabel("Abbrechen");
		add(button3);
		button3.setBackground(java.awt.Color.lightGray);
		button3.setBounds(192,480,86,24);
		button2.setLabel("OK");
		add(button2);
		button2.setBackground(java.awt.Color.lightGray);
		button2.setBounds(312,480,84,24);
		label8.setText("Variationen");
		add(label8);
		label8.setBounds(24,408,108,24);
		label7.setText("Ablaufbeschreibung");
		add(label7);
		label7.setBounds(24,252,120,24);
		label6.setText("Invarianten");
		add(label6);
		label6.setBounds(24,216,108,24);
		label5.setText("Nachbedingungen");
		add(label5);
		label5.setBounds(24,180,108,24);
		label2.setText("Akteur");
		add(label2);
		label2.setBounds(24,108,108,24);
		label1.setText("Name");
		add(label1);
		label1.setBounds(24,72,108,24);
		label4.setText("Vorbedingungen");
		add(label4);
		label4.setBounds(24,144,108,24);
		//FileDialog zum Speichern des UseCases
		
		UseCaseSpeichern.setMode(FileDialog.SAVE);
		UseCaseSpeichern.setTitle("Save");
		UseCaseSpeichern.setFile("*.use");
		//Dem Frame einen Titel geben
		setTitle("Bitte UseCase eingeben");
		

		//Listener
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		button4.addActionListener(lSymAction);
		button3.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
	

	}
	
	//Konstruktor
	public UseCaseEM(String title)
	{
		this();
		setTitle(title);
	}

	//2. Konstruktor (um vorhandene Eingaben zu fllen)
	public UseCaseEM(UseCase uc)
	{
		this();
		setTitle(uc.getName());
		UseCaseName.setText(uc.getName());
		UseCaseNummer.setText(uc.getNummer());
		UseCaseAkteur.setText(uc.getAkteur());
		UseCaseVorbed.setText(uc.getVorbedingungen());
		UseCaseNachbed.setText(uc.getNachbedingungen());
		UseCaseInvar.setText(uc.getInvarianten());
		UseCaseAblauf.insert(uc.getAblaufbeschreibung(),0);
		UseCaseVariationen.setText(uc.getVariationen());
		dialog = uc.getDialog();
		ucerw1 = uc.getAnforderungen();
		ucerw2 = uc.getAusnahmen();
		ucerw3 = uc.getRegeln();
		ucerw4 = uc.getServices();
		ucerw5 = uc.getAnsprechpartner();
		ucerw6 = uc.getAnmerkungen();
		ucerw7 = uc.getDialogbeispiel();


	}


	//Methoden fr den Frame (zum schliessen etc.)
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	static public void main (String args[])
	{
		(new UseCaseEM()).setVisible(true);
	}

	public void addNotify()
	{
		
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == UseCaseEM.this)
			UseCaseEM_WindowClosing(event);
		}
	}

	void UseCaseEM_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();
	}
	
	
	//Variablen
	java.awt.Label label3 = new java.awt.Label();
	java.awt.TextField UseCaseNummer = new java.awt.TextField();
	java.awt.TextField UseCaseName = new java.awt.TextField();
	java.awt.TextField UseCaseAkteur = new java.awt.TextField();
	java.awt.TextField UseCaseVorbed = new java.awt.TextField();
	java.awt.TextField UseCaseNachbed = new java.awt.TextField();
	java.awt.TextField UseCaseInvar = new java.awt.TextField();
	java.awt.TextArea UseCaseAblauf = new java.awt.TextArea();
	java.awt.TextField UseCaseVariationen = new java.awt.TextField();
	java.awt.Button button4 = new java.awt.Button();
	java.awt.Button button3 = new java.awt.Button();
	java.awt.Button button2 = new java.awt.Button();
	java.awt.Label label8 = new java.awt.Label();
	java.awt.Label label7 = new java.awt.Label();
	java.awt.Label label6 = new java.awt.Label();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.FileDialog UseCaseSpeichern = new java.awt.FileDialog(this);

	//Variablen um Sachen aus der ERW. Maske zu holen:
	String ucerw1="  ";
	String ucerw2="  ";
	String ucerw3="   ";
	String ucerw4="   ";
	String ucerw5="  ";
	String ucerw6="  ";
	String ucerw7="  ";

	String dialog="   ";



	//Listener
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button4)
				button4_ActionPerformed(event);
			if (object == button3)
				button3_ActionPerformed(event);
			else if (object == button2)
				button2_ActionPerformed(event);
		}
	}

	void button4_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		button4_ActionPerformed_Interaction1(event);
	}

	void button4_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// UseCaseErwmaske Create and show the UseCaseErwmaske
			(new UseCaseErwmaske(this, UseCaseName.getText())).setVisible(true);
			this.setVisible(false);
		} catch (Exception e) {
		}
	}

	void button3_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		button3_ActionPerformed_Interaction1(event);
	}

	void button3_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// UseCaseEM Hide the UseCaseEM
			this.setVisible(false);
		} catch (Exception e) {
		}
	}

	void button2_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		button2_ActionPerformed_Interaction1(event);

		button2_ActionPerformed_Interaction2(event);
	}

	void button2_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// UseCaseSpeichern Show the FileDialog
			UseCaseSpeichern.setVisible(true);

			//UseCaseinstanz erzeugen

			String ucv = "";
			if(UseCaseVariationen.getText()!= null){
				ucv = UseCaseVariationen.getText()+" ";
			}


			String uca = "uca";
			if(UseCaseAblauf.getText()!= null){
				uca = UseCaseAblauf.getText()+"  ";
			}


			String ucn = "ucn";
			if(UseCaseName.getText()!= null){
				ucn = UseCaseName.getText()+"  ";
			}

			String ucnu = "ucnu";
			if(UseCaseNummer.getText()!= null){
				ucnu = UseCaseNummer.getText()+"  ";
			}


			String ucak = "ucak";
			if(UseCaseAkteur.getText()!= null){
				ucak = UseCaseAkteur.getText()+"  ";
			}


			String ucvo = "ucvo";
			if(UseCaseVorbed.getText()!= null){
				ucvo = UseCaseVorbed.getText()+" ";
			}


			String ucna = "ucna";
			if(UseCaseNachbed.getText()!= null){
				ucna = UseCaseNachbed.getText()+"  ";
			}


			String uci = "uci";
			if(UseCaseInvar.getText()!= null){
				uci = UseCaseInvar.getText()+"  ";
			}
			dialog=dialog+"  ";
			String ucerw1q=ucerw1+" ";
			String ucerw2q=ucerw2+" ";
			String ucerw3q=ucerw3+" ";
			String ucerw4q=ucerw4+" ";
			String ucerw5q=ucerw5+" ";
			String ucerw6q=ucerw6+" ";
			String ucerw7q=ucerw7+" ";





			UseCase Usecase1 = new UseCase(UseCaseSpeichern.getFile(),ucn,ucnu,ucak,ucvo,ucna,uci,uca,ucv,dialog,
				ucerw1q,
				ucerw2q,
				ucerw3q,
				ucerw4q,
				ucerw5q,
				ucerw6q,
				ucerw7q);



			Usecase1.speichern();
			usecaseMaler.malen(Usecase1);
	

		} catch (Exception e) {
		}
	}

	void button2_ActionPerformed_Interaction2(java.awt.event.ActionEvent event)
	{
		try {
		
			this.setVisible(false);
		} catch (Exception e) {
		}
	}

	//Funktion zum setzen der Erweiterungswerte aus der Erweiterten-EM
	public void setErweiterungen(String a, String b, String c, String d, String e, String f, String g)
	{
		ucerw1 = a;
		ucerw2 = b;
		ucerw3 = c;
		ucerw4 = d;
		ucerw5 = e;
		ucerw6 = f;
		ucerw7 = g;
	}
}