// Klasse zur Klasse UseCaseErwmaske
// Autor: Ralph Carrie


import java.awt.*;
import java.beans.*;

public class UseCaseErwmaske extends java.awt.Frame
{
	public UseCaseErwmaske()
	{
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setFont(new Font("Dialog", Font.PLAIN, 14));
		setSize(381,372);
		setVisible(false);
		
		add(UseCaseNichtfunkt);
		UseCaseNichtfunkt.setBounds(216,24,110,27);
		
		add(UseCaseAusnahmen);
		UseCaseAusnahmen.setBounds(216,60,110,27);
		
		add(UseCaseRegeln);
		UseCaseRegeln.setBounds(216,96,110,27);
		
		add(UseCaseServices);
		UseCaseServices.setBounds(216,132,110,27);
		
		add(UseCaseAnprech);
		UseCaseAnprech.setBounds(216,168,110,27);
		
		add(UseCaseAnmerk);
		UseCaseAnmerk.setBounds(216,204,110,27);
		
		add(UseCaseDiaBsp);
		UseCaseDiaBsp.setBounds(216,240,110,27);
		
		button5.setLabel("Lschen");
		add(button5);
		button5.setBackground(java.awt.Color.lightGray);
		button5.setBounds(24,312,86,24);
		
		button6.setLabel("Abbrechen");
		add(button6);
		button6.setBackground(java.awt.Color.lightGray);
		button6.setBounds(144,312,86,24);
		
		button7.setLabel("OK");
		add(button7);
		button7.setBackground(java.awt.Color.lightGray);
		button7.setBounds(264,312,86,24);
		
		label8.setText("Anmerkungen");
		add(label8);
		label8.setBounds(24,204,108,24);
		
		label1.setText("Services");
		add(label1);
		label1.setBounds(24,132,108,24);
		
		label2.setText("Regeln");
		add(label2);
		label2.setBounds(24,96,108,24);
		
		label3.setText("Ausnahmen");
		add(label3);
		label3.setBounds(24,60,108,24);
		
		label4.setText("Nicht-funktionale-Anforderungen");
		add(label4);
		label4.setFont(new Font("Dialog", Font.PLAIN, 12));
		label4.setBounds(24,24,180,24);
		
		label5.setText("Ansprechpartner");
		add(label5);
		label5.setBounds(24,168,108,24);
		
		label6.setText("Dialogbeispiele");
		add(label6);
		label6.setBounds(24,240,108,24);
		
		setTitle("Use-Case erweiterte Eingaben");
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		button7.addActionListener(lSymAction);
		button5.addActionListener(lSymAction);
		button6.addActionListener(lSymAction);
		//}}

		//{{INIT_MENUS
		//}}

	}

	public UseCaseErwmaske(String title)
	{
		this();
		setTitle(title);
	}
	
	public UseCaseErwmaske(UseCaseEM ucem, String title)
	{
		this();
		setTitle(title);
		usecase=ucem;
		UseCaseNichtfunkt.setText(usecase.ucerw1);
		UseCaseAusnahmen.setText(usecase.ucerw2);
		UseCaseRegeln.setText(usecase.ucerw3);
		UseCaseServices.setText(usecase.ucerw4);
		UseCaseAnprech.setText(usecase.ucerw5);
		UseCaseAnmerk.setText(usecase.ucerw6);
		UseCaseDiaBsp.setText(usecase.ucerw7);
	} 
	
	
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	static public void main (String args[])
	{
		(new UseCaseErwmaske()).setVisible(true);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == UseCaseErwmaske.this)
			UseCaseErwmaske_WindowClosing(event);
		}
	}

	void UseCaseErwmaske_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	java.awt.TextField UseCaseNichtfunkt = new java.awt.TextField();
	java.awt.TextField UseCaseAusnahmen = new java.awt.TextField();
	java.awt.TextField UseCaseRegeln = new java.awt.TextField();
	java.awt.TextField UseCaseServices = new java.awt.TextField();
	java.awt.TextField UseCaseAnprech = new java.awt.TextField();
	java.awt.TextField UseCaseAnmerk = new java.awt.TextField();
	java.awt.TextField UseCaseDiaBsp = new java.awt.TextField();
	java.awt.Button button5 = new java.awt.Button();
	java.awt.Button button6 = new java.awt.Button();
	java.awt.Button button7 = new java.awt.Button();
	java.awt.Label label8 = new java.awt.Label();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.Label label6 = new java.awt.Label();
	//}}

	//{{DECLARE_MENUS
	//}}
	
	UseCaseEM usecase;


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button7)
				button7_ActionPerformed(event);
			else if (object == button5)
				button5_ActionPerformed(event);
			else if (object == button6)
				button6_ActionPerformed(event);
		}
	}

	void button7_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button7_ActionPerformed_Interaction1(event);
		// to do: code goes here.
	}

	void button7_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.setVisible(false);
			
			usecase.setErweiterungen(UseCaseNichtfunkt.getText(),UseCaseAusnahmen.getText(),
						 UseCaseRegeln.getText(), UseCaseServices.getText(), UseCaseAnprech.getText(), 
						 UseCaseAnmerk.getText(), UseCaseDiaBsp.getText());
						
			usecase.setVisible(true);
		} catch (Exception e) {
		}
	}

	void button5_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		button5_ActionPerformed_Interaction1(event);
			 
		button5_ActionPerformed_Interaction2(event);
			 
		button5_ActionPerformed_Interaction3(event);
			 
		button5_ActionPerformed_Interaction4(event);
			 
		button5_ActionPerformed_Interaction5(event);
			 
		button5_ActionPerformed_Interaction6(event);
			 
		button5_ActionPerformed_Interaction7(event);
	}

	void button5_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// textField1 Clear the text for TextField
			UseCaseNichtfunkt.setText("");
		} catch (Exception e) {
		}
	}

	void button5_ActionPerformed_Interaction2(java.awt.event.ActionEvent event)
	{
		try {
			// textField2 Clear the text for TextField
			UseCaseAusnahmen.setText("");
		} catch (Exception e) {
		}
	}

	void button5_ActionPerformed_Interaction3(java.awt.event.ActionEvent event)
	{
		try {
			// textField3 Clear the text for TextField
			UseCaseRegeln.setText("");
		} catch (Exception e) {
		}
	}

	void button5_ActionPerformed_Interaction4(java.awt.event.ActionEvent event)
	{
		try {
			// textField4 Clear the text for TextField
			UseCaseServices.setText("");
		} catch (Exception e) {
		}
	}

	void button5_ActionPerformed_Interaction5(java.awt.event.ActionEvent event)
	{
		try {
			// textField5 Clear the text for TextField
			UseCaseAnprech.setText("");
		} catch (Exception e) {
		}
	}

	void button6_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		button6_ActionPerformed_Interaction1(event);
	}

	void button6_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// UseCaseErwmaske Hide the UseCaseErwmaske
			this.setVisible(false);
		} catch (Exception e) {
		}
	}

	void button5_ActionPerformed_Interaction6(java.awt.event.ActionEvent event)
	{
		try {
			// textField6 Clear the text for TextField
			UseCaseAnmerk.setText("");
		} catch (Exception e) {
		}
	}

	void button5_ActionPerformed_Interaction7(java.awt.event.ActionEvent event)
	{
		try {
			// textField7 Clear the text for TextField
			UseCaseDiaBsp.setText("");
		} catch (Exception e) {
		}
	}
}