// Klasse zur Klasse VerbindungEM
// Autor: Ralph Carrie

import java.awt.*;
import java.beans.*;
import java.io.*;



public class VerbindungEM extends java.awt.Frame
{
	public VerbindungEM()
	{
		//Layout des Frames
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setFont(new Font("Dialog", Font.PLAIN, 14));
		setSize(481,494);
		setVisible(false);
		
		add(VerbName);
		VerbName.setBounds(192,24,110,27);
		
		add(VerbStereo);
		VerbStereo.setBounds(192,72,110,27);
		
		add(VerbBez);
		VerbBez.setBounds(192,120,110,24);
		
		LeseRichtung.addItem("<");
		LeseRichtung.addItem(">");
		
		add(LeseRichtung);
		LeseRichtung.setBounds(336,120,62,26);
		
		add(VerbZusicherung);
		VerbZusicherung.setBounds(192,168,108,24);
		
		add(VerbEigensch);
		VerbEigensch.setBounds(192,216,110,27);
		
		add(VerbMultL);
		VerbMultL.setBounds(108,300,72,24);
		add(VerbMultR);
		
		VerbMultR.setBounds(300,300,72,24);
		
		button1.setLabel("Pfeil (-spitze)");
		add(button1);
		button1.setBackground(java.awt.Color.lightGray);
		button1.setBounds(300,360,132,24);
		
		label1.setText("Stereotyp");
		add(label1);
		label1.setBounds(48,72,104,26);
		label2.setText("Name");
		add(label2);
		label2.setBounds(60,24,104,26);
		label7.setText("<<");
		add(label7);
		label7.setFont(new Font("Dialog", Font.BOLD, 14));
		label7.setBounds(156,72,24,24);
		label6.setText(">>");
		add(label6);
		label6.setFont(new Font("Dialog", Font.BOLD, 14));
		label6.setBounds(312,72,24,24);
		label3.setText("Beziehungsname");
		add(label3);
		label3.setBounds(12,120,120,24);
		label4.setText("Leserichtung");
		add(label4);
		label4.setBounds(336,84,96,24);
		label5.setText("Zusicherung");
		add(label5);
		label5.setBounds(36,168,96,24);
		label10.setText("{");
		add(label10);
		label10.setFont(new Font("Dialog", Font.BOLD, 18));
		label10.setBounds(168,168,12,24);
		label11.setText("}");
		add(label11);
		label11.setFont(new Font("Dialog", Font.BOLD, 18));
		label11.setBounds(312,168,12,24);
		label8.setText("Eigenschaftswerte");
		add(label8);
		label8.setBounds(12,216,132,24);
		label9.setText("{");
		add(label9);
		label9.setFont(new Font("Dialog", Font.BOLD, 18));
		label9.setBounds(168,216,12,24);
		label12.setText("}");
		add(label12);
		label12.setFont(new Font("Dialog", Font.BOLD, 18));
		label12.setBounds(312,216,12,24);
		label13.setText("Multiplizitt links");
		add(label13);
		label13.setBounds(96,264,104,26);
		label14.setText("Multiplizitt rechts");
		add(label14);
		label14.setBounds(276,264,120,24);
		
		button2.setLabel("Abbrechen");
		add(button2);
		button2.setBackground(java.awt.Color.lightGray);
		button2.setBounds(120,432,86,24);
		
		button3.setLabel("OK");
		add(button3);
		button3.setBackground(java.awt.Color.lightGray);
		button3.setBounds(240,432,86,24);
		
		VerbindungSpeichern.setMode(FileDialog.SAVE);
		VerbindungSpeichern.setTitle("Save");
		VerbindungSpeichern.setFile("*.ver");
				
		
		
		
		
		// SaveFileDialog
		setTitle("Bitte Verbindung eingeben");



		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
		button3.addActionListener(lSymAction);
		

	}

	//1. Konstruktor
	public VerbindungEM(String title)
	{
		this();
		setTitle(title);
		LeseRichtung.select(1);
	}
	
	//2. Konstruktor
	public VerbindungEM(Verbindung v)
	{
		this();
		setTitle(v.Name);
		VerbName.setText(v.Name);
		VerbStereo.setText(v.Stereotyp);
		VerbBez.setText(v.Beziehungsname);
		LeseRichtung.select(v.Leserichtung);
		VerbZusicherung.setText(v.Zusicherung);
		VerbEigensch.setText(v.Eigenschaftswerte);
		VerbMultL.setText(v.Mlinks);
		VerbMultR.setText(v.Mrechts);
		boolean verbemgest = v.isGestrichelt;
		int verbemspitze = v.Spitze;
		int verbemspitzenform = v.SpitzenForm;
		
		
	}
	
	
	//Frame Listeners
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	static public void main (String args[])
	{
		(new VerbindungEM()).setVisible(true);
	}

	public void addNotify()
	{
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;


		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}


	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == VerbindungEM.this)
			VerbindungEM_WindowClosing(event);
		}
	}

	void VerbindungEM_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		
	}
	
	
	//Variablen

	java.awt.TextField VerbName = new java.awt.TextField();
	java.awt.TextField VerbStereo = new java.awt.TextField();
	java.awt.TextField VerbBez = new java.awt.TextField();
	java.awt.Choice LeseRichtung = new java.awt.Choice();
	java.awt.TextField VerbZusicherung = new java.awt.TextField();
	java.awt.TextField VerbEigensch = new java.awt.TextField();
	java.awt.TextField VerbMultL = new java.awt.TextField();
	java.awt.TextField VerbMultR = new java.awt.TextField();
	java.awt.Button button1 = new java.awt.Button();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Label label7 = new java.awt.Label();
	java.awt.Label label6 = new java.awt.Label();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.Label label10 = new java.awt.Label();
	java.awt.Label label11 = new java.awt.Label();
	java.awt.Label label8 = new java.awt.Label();
	java.awt.Label label9 = new java.awt.Label();
	java.awt.Label label12 = new java.awt.Label();
	java.awt.Label label13 = new java.awt.Label();
	java.awt.Label label14 = new java.awt.Label();
	java.awt.Button button2 = new java.awt.Button();
	java.awt.Button button3 = new java.awt.Button();
	java.awt.FileDialog VerbindungSpeichern = new java.awt.FileDialog(this);

	//die variablen, die von der layout maske noch genderrt werden knnen
	boolean verbemgest = false;
	int verbemspitze = 2;
	int verbemspitzenform = 0;
	
	

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_ActionPerformed(event);
			else if (object == button2)
				button2_ActionPerformed(event);
			else if (object == button3)
				button3_ActionPerformed(event);
			
		}
	}

	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		button1_ActionPerformed_Interaction2(event);
	}

	void button1_ActionPerformed_Interaction2(java.awt.event.ActionEvent event)
	{
		try {
			// VerbindungsLayoutEM Create and show the VerbindungsLayoutEM with a title; VerbName Get the contents of the TextField
			this.setVisible(false);
			(new VerbindungsLayoutEM(this, VerbName.getText())).setVisible(true);
			
		} catch (Exception e) {
		}
	}

	void button2_ActionPerformed(java.awt.event.ActionEvent event)
	{
		button2_ActionPerformed_Interaction1(event);
	}

	void button2_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// VerbindungEM Hide the VerbindungEM
			this.setVisible(false);
		} catch (Exception e) {
		}
	}

	void button3_ActionPerformed(java.awt.event.ActionEvent event)
	{
			 
		button3_ActionPerformed_Interaction1(event);
			 
		button3_ActionPerformed_Interaction2(event);
	}

	void button3_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// VerbindungSpeichern Show the FileDialog
			VerbindungSpeichern.setVisible(true);
			
			//Verbindungsinstnaz erzeugen
			Verbindung verbindung = new Verbindung (
				VerbindungSpeichern.getFile(),
				VerbName.getText(), VerbStereo.getText(), VerbBez.getText(), VerbZusicherung.getText(), VerbEigensch.getText(), 
				VerbMultL.getText(), VerbMultR.getText(), LeseRichtung.getSelectedIndex(), verbemgest, verbemspitze, verbemspitzenform);
		
			verbindung.speichern();	
			verbindungsMaler.malen(verbindung);				
			
		} catch (Exception e) {
		}
	}

	void button3_ActionPerformed_Interaction2(java.awt.event.ActionEvent event)
	{
		try {
			// VerbindungEM Hide the VerbindungEM
			this.setVisible(false);
		} catch (Exception e) {
		}
	}
	public void setGest(boolean i)
	{
		verbemgest = i;
	}
	public void setSpitze(int i)
	{
		verbemspitze = i;
	}
	public void setSpitzenform(int i)
	{
		verbemspitzenform = i;
	}
}