// Klasse Klasse

import java.util.*;
import java.io.*;
import java.util.Vector;




public class Klasse implements Serializable{
    private String Name;
    private String Stereotyp;
    private String Paket;
    private String PaketKlasse;
    private String Eigenschaftswerte;
    private boolean isStatic;
    private int Eigenschaften;  // 0=public 1=private 2=protected t.b.c.
    private Vector Attribute;
    private Vector Operationen;
    int ansicht;    // 0=einfach 1=standard 2=komplett
	String Filename;
    
    Klasse(String Fn, String N, String ST, String P, String PK, String EW, boolean iS,int EI, Vector A, Vector O) {
        Filename = Fn;
        Name = N;
        Stereotyp = ST;
        Paket = P;
        PaketKlasse = PK;
        Eigenschaftswerte = EW;
        Eigenschaften = EI;
        Attribute = A;
        Operationen = O;
        isStatic = iS;
        }
        
    public Klasse(Klasse K) {
        Name = K.getName();
        Stereotyp = K.getStereotyp();
        Paket = K.getPaket();
        PaketKlasse = K.getPaketKlasse();
        Eigenschaftswerte = K.getEigenschaftswerte();
        Attribute = K.getAttribute();
        Operationen = K.getOperationen();
        }
    
// get- und set-Methoden

    public String getFilename() {
        return Filename;
        }
    
    public String getName() {
        return Name;
        }
        
    
    public String getStereotyp() {
        return Stereotyp;
        }
        
            
    public String getPaket() {
        return Paket;
        }
        
            
    public String getPaketKlasse() {
        return PaketKlasse;
        }
        
            
    public String getEigenschaftswerte() {
        return Eigenschaftswerte;
        }
        
           
    public Vector getAttribute() {
        return Attribute;
        }
        
   
    public Vector getOperationen() {
        return Operationen;
	}

    public int getEigenschaften() {
        return Eigenschaften;
	}

    public boolean getisStatic() {
        return isStatic;
	}
	
	// speichert ein Klassen Objekt in einer Datei mittels eines ObjectOutputStream
   	public void speichern(){
	    try {
			FileOutputStream FOS = new FileOutputStream(Filename);
    		ObjectOutputStream OOS = new ObjectOutputStream(FOS);
	        OOS.writeObject(this);
	        OOS.close();
		    }
		catch(Exception e) {}
	}
	
	// ruft eine Klassenmaske auf, um die Daten der Klasse zu editieren
	public void editieren(Klasse k) {
	    (new Klassenmaske(k)).setVisible(true);
	}
	    
		
}
    
    
