//Klasse zur Klasse UseCase
//Autor Ralph Carrie


import java.io.*;
import java.util.*;

//Variablen


public class UseCase implements Serializable {
    private String Name;
    private String Nummer;
    private String Akteur;
    private String Vorbedingungen;
    private String Nachbedingungen;
    private String Invarianten;
    private String Ablaufbeschreibung;
    private String Variationen;
    private String Dialog;
    private String ENfAnforderungen;//E fr erweitert(nur erweiterter Fall)
    private String EAusnahmen;
    private String ERegeln;
    private String EServices;
    private String EAnsprechp;
    private String EAnmerkungen;
    private String EDialogbsp;
    int ansicht;    // 0=einfach 1=standard 2=komplett
    FileOutputStream FOS;
    ObjectOutputStream OOS;
    String Filename;
	
		//einfacher Konstruktor
		public UseCase(String Filename, String N, String Nr, String A, String Vb, String NB, String I, String AB, String V, String D) {
        this.Filename = Filename;
        Name = N;
        Nummer = Nr;
        Akteur = A;
        Vorbedingungen = Vb;
        Nachbedingungen = NB;
        Invarianten = I;
        Ablaufbeschreibung = AB;
        Variationen = V;
		Dialog = D;
        }
    
		//erweiterter Konstruktor, keine Ahnung, ob man dann den einfachen noch braucht, erstmal dagelassen
		public UseCase(String Filename, String N, String Nr, String A, String Vb, String NB, String I, String AB, String V, String D,
		String NfA,String Ausn,String Rg,String Serv,String An,String Anm,String Dbsp) {
        this.Filename = Filename;
		Name = N;
        Nummer = Nr;
        Akteur = A;
        Vorbedingungen = Vb;
        Nachbedingungen = NB;
        Invarianten = I;
        Ablaufbeschreibung = AB;
        Variationen = V;
		Dialog = D;
				ENfAnforderungen = NfA;
				EAusnahmen = Ausn;
				ERegeln = Rg;
				EServices = Serv;
				EAnsprechp = An;
				EAnmerkungen = Anm;
				EDialogbsp = Dbsp;
        }
		
    
	//Methoden um die Variablen zu bergeben
	public String getName() {
        return Name;
        }
        
        
    public String getNummer() {
        return Nummer;
        }
        
        
    public String getAkteur() {
        return Akteur;
        }
        
        
    public String getVorbedingungen() {
        return Vorbedingungen;
        }
        
        
    public String getNachbedingungen() {
        return Nachbedingungen;
        }
    public String getInvarianten() {
        return Invarianten;
        }
    
	public String getAblaufbeschreibung()
	{
		return Ablaufbeschreibung;
	}
	
	public String getVariationen()
	{
		return Variationen;
	}
	
	
		
	 public String getDialog() {
        return Dialog;
		}	
    
	public String getAnforderungen() {
        return ENfAnforderungen;
        }
	public String getAusnahmen() {
        return EAusnahmen;
        }
    public String getRegeln() {
        return ERegeln;
        }
    
        
    public String getServices() {
        return EServices;
        }
	
    	
	public String getAnsprechpartner() {
        return EAnsprechp;
        }
        
        
    public String getAnmerkungen() {
        return EAnmerkungen;
        }
        
        
    public String getDialogbeispiel() {
        return EDialogbsp;
        }
        
    
	public void speichern(){
	    try {
    	    FileOutputStream FOS = new FileOutputStream(Filename);
	        ObjectOutputStream OOS = new ObjectOutputStream(FOS);
	        OOS.writeObject(this);
	        OOS.close();
		}
		catch(Exception e) {}
    }
	
	
	public void editieren(UseCase uc)
	{
	(new UseCaseEM(uc)).setVisible(true);
	
	}
	
	
}
    
