// Klasse zur Klasse VerbindungsLayoutEM
// Autor: Ralph Carrie

import java.awt.*;
import java.beans.*;



public class VerbindungsLayoutEM extends java.awt.Frame
{
	public VerbindungsLayoutEM()
	{
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setFont(new Font("Dialog", Font.PLAIN, 14));
		setSize(649,353);
		setVisible(false);
		
		durch.setCheckboxGroup(Group1);
		durch.setState(true);
		durch.setLabel("durchgezogen");
		add(durch);
		durch.setBounds(12,72,120,24);
		
		unter.setCheckboxGroup(Group1);
		unter.setLabel("unterbrochen");
		add(unter);
		unter.setBounds(12,108,108,24);
		label1.setText("Pfeillinie");
		add(label1);
		label1.setBackground(java.awt.Color.lightGray);
		label1.setBounds(12,36,60,24);
		label2.setText("Pfeilspitze");
		add(label2);
		label2.setBackground(java.awt.Color.lightGray);
		label2.setBounds(240,36,72,24);
		
		links.setCheckboxGroup(Group2);
		links.setLabel("rechts");
		add(links);
		links.setBounds(240,72,120,24);
		rechts.setCheckboxGroup(Group2);
		rechts.setState(true);
		rechts.setLabel("links");
		add(rechts);
		rechts.setBounds(240,108,120,24);
		keine.setCheckboxGroup(Group2);
		keine.setLabel("keine Spitze");
		add(keine);
		keine.setBounds(240,144,120,24);
		
		offen.setCheckboxGroup(Group3);
		offen.setLabel("offen (->)");
		add(offen);
		offen.setBounds(384,72,120,24);
		
		dreieckun.setCheckboxGroup(Group3);
		dreieckun.setLabel("dreieckig unausgefllt");
		add(dreieckun);
		dreieckun.setBounds(384,108,204,24);
		dreieckaus.setCheckboxGroup(Group3);
		dreieckaus.setLabel("dreieckig ausgefllt");
		add(dreieckaus);
		dreieckaus.setBounds(384,144,204,24);
		rauteun.setCheckboxGroup(Group3);
		rauteun.setLabel("Raute unausgefllt");
		add(rauteun);
		rauteun.setBounds(384,180,168,24);
		rauteaus.setCheckboxGroup(Group3);
		rauteaus.setLabel("Raute ausgefllt");
		add(rauteaus);
		rauteaus.setBounds(384,216,168,24);
		add(canvas1);
		canvas1.setBackground(java.awt.Color.cyan);
		canvas1.setBounds(168,36,1,264);
		button1.setLabel("Abbrechen");
		add(button1);
		button1.setBackground(java.awt.Color.lightGray);
		button1.setBounds(228,312,86,24);
		button2.setLabel("OK");
		add(button2);
		button2.setBackground(java.awt.Color.lightGray);
		button2.setBounds(360,312,86,24);
		setTitle("A Simple Frame");
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
		//}}

		//{{INIT_MENUS
		//}}
		
		
	
		


	}

	public VerbindungsLayoutEM(VerbindungEM verbindungsem, String title)
	{
		this();
		setTitle(title);
		VerbindungsEm = verbindungsem;
		setGruppe1(VerbindungsEm.verbemgest);
		setGruppe2(VerbindungsEm.verbemspitze);
		setGruppe3(VerbindungsEm.verbemspitzenform);
	}
	
	
	
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	static public void main (String args[])
	{
		(new VerbindungsLayoutEM()).setVisible(true);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == VerbindungsLayoutEM.this)
			VerbindungsLayoutEM_WindowClosing(event);
		}
	}

	void VerbindungsLayoutEM_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	java.awt.Checkbox durch = new java.awt.Checkbox();
	java.awt.CheckboxGroup Group1 = new java.awt.CheckboxGroup();
	java.awt.Checkbox unter = new java.awt.Checkbox();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Checkbox links = new java.awt.Checkbox();
	java.awt.CheckboxGroup Group2 = new java.awt.CheckboxGroup();
	java.awt.Checkbox rechts = new java.awt.Checkbox();
	java.awt.Checkbox keine = new java.awt.Checkbox();
	java.awt.Checkbox offen = new java.awt.Checkbox();
	java.awt.CheckboxGroup Group3 = new java.awt.CheckboxGroup();
	java.awt.Checkbox dreieckun = new java.awt.Checkbox();
	java.awt.Checkbox dreieckaus = new java.awt.Checkbox();
	java.awt.Checkbox rauteun = new java.awt.Checkbox();
	java.awt.Checkbox rauteaus = new java.awt.Checkbox();
	java.awt.Canvas canvas1 = new java.awt.Canvas();
	java.awt.Button button1 = new java.awt.Button();
	java.awt.Button button2 = new java.awt.Button();
	//Fr den Konstrukor
	VerbindungEM VerbindungsEm;
	
	//Variablen zum Auslesen der Radiobuttons
	boolean a;
	int b,c;
	
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_ActionPerformed(event);
			else if (object == button2)
				button2_ActionPerformed(event);
		}
	}

	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		button1_ActionPerformed_Interaction1(event);
	}

	void button1_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// VerbindungsLayoutEM Hide the VerbindungsLayoutEM
			this.setVisible(false);
		
			
			
		} catch (Exception e) {
		}
	}

	void button2_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		button2_ActionPerformed_Interaction1(event);
	}

	void button2_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// VerbindungsLayoutEM Hide the VerbindungsLayoutEM
			this.setVisible(false);
			
			
			a = eigenschaften1();
			b = eigenschaften2();
			c = eigenschaften3();
			VerbindungsEm.setGest(a);
			VerbindungsEm.setSpitze(b);
			VerbindungsEm.setSpitzenform(c);
			VerbindungsEm.setVisible(true);
			
		} catch (Exception e) {
		}
	}

		
	
	public boolean eigenschaften1()
	{
		if (Group1.getSelectedCheckbox() == durch)
		{
			return false;
		}
		else if (Group1.getSelectedCheckbox() == unter)
		{
			return true;
		}
		else return false;
	}
	
	public int eigenschaften2()
	{
		if (Group2.getSelectedCheckbox() == links)
		{
			return 0;
		}
		else if (Group2.getSelectedCheckbox() == rechts)
		{
			return 1;
		}
		else if (Group2.getSelectedCheckbox() == keine)
		{
			return 2;
		}
		else return 2;
	}
	
	public int eigenschaften3()
	{
		if (Group3.getSelectedCheckbox() == offen)
		{
			return 0;
		}
		else if (Group3.getSelectedCheckbox() == dreieckun)
		{
			return 1;
		}
		else if (Group3.getSelectedCheckbox() == dreieckaus)
		{
			return 2;
		}
		else if (Group3.getSelectedCheckbox() == rauteun)
		{
			return 3;
		}
		else if (Group3.getSelectedCheckbox() == rauteaus)
		{
			return 4;
		}
		else return 0;
	}
		
		public void setGruppe1(boolean i)
		{
			if (i == false)
			{durch.setState(true);
			}
			if (i == true)
			{unter.setState(true);
			}
		}
		public void setGruppe2(int i)
		{
			if (i == 0)
			{rechts.setState(true);
			}
			//es ist leider andersherum, wenn der pfeil links
			//sein soll muss man rechts true setzen
			if (i == 1)
			{links.setState(true);
			}
			if (i == 2)
			{keine.setState(true);
			}
			else 
			{keine.setState(true);
			}
		
		}	
		public void setGruppe3(int i)
		{
			if (i == 0)
			{offen.setState(true);
			}
			//es ist leider andersherum, wenn der pfeil links
			//sein soll muss man rechts true setzen
			if (i == 1)
			{dreieckun.setState(true);
			}
			if (i == 2)
			{dreieckaus.setState(true);
			}
			if (i == 3)
			{rauteun.setState(true);
			}
			if (i == 4)
			{rauteaus.setState(true);
			}
			else 
			{offen.setState(true);
			}
		
		}	
}
